<template>
  <div class="main-contain">
    <div class="position">
      <bread-crumb :crumbs="crumbs"></bread-crumb>
    </div>
    <div class="app-container">
      <div class="cell clearfix">
        <label class="title"> <span class="name">日期查询</span> : </label>
        <el-date-picker
          v-model="listQuery.start_time"
          prefix-icon="el-icon-date"
          @change="changeTime"
          :editable="false"
          style="width: 196px;"
          type="date"
          placeholder="选择日期时间"
          align="right"
          format="yyyy-MM-dd"
          value-format="yyyy-MM-dd"
        ></el-date-picker>
        <span class>-</span>
        <el-date-picker
          v-model="listQuery.end_time"
          prefix-icon="el-icon-date"
          @change="changeEndTime"
          :editable="false"
          style="width: 196px;"
          type="date"
          placeholder="选择日期时间"
          align="right"
          format="yyyy-MM-dd"
          value-format="yyyy-MM-dd"
        ></el-date-picker>
      </div>
      <div class="cell clearfix">
        <label class="title"> <span class="name">透析龄</span> : </label>
        <div class="time">
          <ul class>
            <li
              :class="item.value == dialysisAge ? 'active' : ''"
              @click="selectdialysisAges(item.value)"
              v-for="item in dialysisAgeOptions"
              :key="item.value"
            >
              {{ item.label }}
            </li>
          </ul>
        </div>
      </div>
      <div class="cell clearfix">
        <label class="title"> <span class="name">转归状态</span> : </label>
        <div class="time">
          <ul class>
            <li
              :class="item.lapseto == lapsetoType ? 'active' : ''"
              @click="selectLapseTo(item.lapseto)"
              v-for="item in lapsetoState"
              :key="item.value"
            >
              {{ item.label }}
            </li>
          </ul>
        </div>
      </div>

      <div class="cell clearfix">
        <label class="title"> <span class="name">检验项目</span> : </label>
        <el-select
          v-model="listQuery.project_id"
          placeholder="请选择"
          @change="changeModel()"
        >
          <el-option label="全部" value=""></el-option>
          <el-option
            v-for="item in projectOptions"
            :key="item.project_id"
            :label="item.project_name"
            :value="item.project_id"
          ></el-option>
        </el-select>
      </div>

      <div class="cqd-dataTitle">统计图</div>
      <el-row :gutter="32">
        <el-col :xs="24" :sm="24" :lg="24">
          <div class="chart-wrapper">
            <pie-chart title="" :options="CompletionOptions" />
          </div>
        </el-col>
      </el-row>

      <div style="height:20px">&nbsp;</div>
      <div class="cqd-dataTitle">统计表</div>
      <el-table
        ref="multipleTable"
        :data="tableData"
        :span-method="mergeSpan"
        border
        fit
        highlight-current-row
        style="width: 100%;margin-top: 10px;"
        :row-style="{ color: '#303133' }"
        :header-cell-style="{
          backgroundColor: 'rgb(245, 247, 250)',
          color: '#606266'
        }"
      >
        <el-table-column
          label="透析号"
          min-width="80"
          property="patient_id"
          align="center"
        >
          <template slot-scope="scope"
            ><span>{{
              getPatientDialysisNo(scope.row.patient_id)
            }}</span></template
          >
        </el-table-column>
        <el-table-column
          label="姓名"
          min-width="80"
          property="patient_id"
          align="center"
        >
          <template slot-scope="scope"
            ><span>{{ getPatientName(scope.row.patient_id) }}</span></template
          >
        </el-table-column>
        <el-table-column
          label="检查项目"
          min-width="80"
          property="project_id"
          align="center"
        >
          <template slot-scope="scope"
            ><span>{{ getProjectName(scope.row.project_id) }}</span></template
          >
        </el-table-column>
        <el-table-column
          label="检查日期"
          min-width="80"
          property="inspect_date"
          align="center"
        >
          <template slot-scope="scope"
            ><span>{{
              getTime(scope.row.inspect_date, "{y}{m}{d}")
            }}</span></template
          >
        </el-table-column>
      </el-table>

      <!-- <pagi-nation title="分页"></pagi-nation> -->

      <el-pagination
        align="right"
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page="listQuery.pate"
        :page-sizes="[10, 20, 50, 100]"
        :page-size="10"
        background
        style="margin-top:20px;"
        layout="total, sizes, prev, pager, next, jumper"
        :total="total"
      ></el-pagination>
    </div>
  </div>
</template>

<script>
import { GetProcessIndicatorsData } from "@/api/qcd";
import PieChart from "./components/PieChart";
import { uParseTime } from "@/utils/tools";
import BreadCrumb from "@/xt_pages/components/bread-crumb";
export default {
  name: "dialysisTotal",
  data() {
    return {
      crumbs: [
        { path: false, name: "科室质控" },
        { path: "/qcd/processindicators", name: "过程指标" }
      ],
      total: 0,
      projectOptions: {},
      patientMap: {},
      CompletionOptions: {
        legend: [],
        series: []
      },
      listQuery: {
        start_time: "",
        end_time: "",
        page: 1,
        limit: 10,
        lapseto: 0,
        project_id: "",
        dialysis_age: 0
      },
      tableData: [],
      tableRowData: [],
      lapsetoType: 0,
      lapsetoState: [
        { value: 0, label: "全部", source: 0, lapseto: 0 },
        { value: 1, label: "转出", source: 0, lapseto: 2 },
        { value: 2, label: "留治", source: 0, lapseto: 1 }
      ],
      dialysisAge: 0,
      dialysisAgeOptions: [
        { value: 0, label: "全部" },
        { value: 1, label: "大于三个月" },
        { value: 2, label: "小于三个月" }
      ]
    };
  },
  created() {
    var nowDate = new Date();
    var nowYear = nowDate.getFullYear();
    var nowMonth = nowDate.getMonth() + 1;
    var nowDay = nowDate.getDate();
    this.listQuery.end_time =
      nowYear +
      "-" +
      (nowMonth < 10 ? "0" + nowMonth : nowMonth) +
      "-" +
      (nowDay < 10 ? "0" + nowDay : nowDay);
    nowDate.setMonth(nowDate.getMonth() - 3);
    nowYear = nowDate.getFullYear();
    nowMonth = nowDate.getMonth() + 1;
    nowDay = nowDate.getDate();
    this.listQuery.start_time =
      nowYear +
      "-" +
      (nowMonth < 10 ? "0" + nowMonth : nowMonth) +
      "-" +
      (nowDay < 10 ? "0" + nowDay : nowDay);
    this.getList();
  },
  methods: {
    getList() {
      GetProcessIndicatorsData(this.listQuery).then(response => {
        if (response.data.state == 0) {
          this.$message.error(response.data.msg);
          return false;
        } else {
          this.tableData = [];
          this.tableRowData = [];
          this.total = response.data.data.total;
          var unfinishedcount = response.data.data.unfinishedcount;
          var finishedcount = this.total - unfinishedcount;
          this.CompletionOptions = {
            legend: [],
            series: []
          };
          this.CompletionOptions.legend.push("定时完成人次");
          this.CompletionOptions.series.push({
            value: finishedcount,
            name: "定时完成人次"
          });
          this.CompletionOptions.legend.push("未时完成人次");
          this.CompletionOptions.series.push({
            value: unfinishedcount,
            name: "未时完成人次"
          });

          var references = response.data.data.references;
          for (const index in references) {
            if (references[index].project_id in this.projectOptions) {
              continue;
            }
            this.$set(
              this.projectOptions,
              references[index].project_id,
              references[index]
            );
          }

          var patients = response.data.data.patients;
          for (const index in patients) {
            if (patients[index].id in this.patientMap) {
              continue;
            }
            this.$set(this.patientMap, patients[index].id, patients[index]);
          }
          var temInspections = {};
          var inspections = response.data.data.inspections;
          for (const index in inspections) {
            var key =
              inspections[index].inspect_date +
              "_" +
              inspections[index].patient_id;
            if (!(key in temInspections)) {
              temInspections[key] = {};
            }
            if (inspections[index].project_id in temInspections[key]) {
              continue;
            }
            temInspections[key][inspections[index].project_id] =
              inspections[index];
          }
          var rowIndex = 0;
          var childIndex = 0;
          for (const key in temInspections) {
            this.tableRowData.push(1);
            var parentIndex = rowIndex;
            childIndex = 0;
            for (const child in temInspections[key]) {
              this.tableData.push(temInspections[key][child]);
              if (childIndex > 0) {
                this.tableRowData[parentIndex] += 1;
                this.tableRowData.push(0);
              }
              childIndex++;
              rowIndex++;
            }
          }
        }
      });
    },
    changeTime() {
      this.getList();
    },
    changeEndTime(val) {
      var time =
        this.getTimestamp(val) - this.getTimestamp(this.listQuery.start_time);
      if (time < 0) {
        this.$message.error("结束时间不能小于开始时间");
        this.listQuery.end_time = "";
      } else {
        this.getList();
      }
    },
    getTimestamp(time) {
      // 把时间日期转成时间戳
      return new Date(time).getTime() / 1000;
    },
    selectLapseTo(lapseto) {
      this.lapsetoType = lapseto;
      this.listQuery.lapseto = lapseto;
      this.getList();
    },
    selectdialysisAges(type) {
      this.dialysisAge = type;
      this.listQuery.dialysis_age = type;
      this.getList();
    },
    changeModel() {
      this.getList();
    },
    handleSizeChange(val) {
      this.listQuery.limit = val;
      this.getList();
    },
    handleCurrentChange(val) {
      this.listQuery.page = val;
      this.getList();
    },
    getTime(value, temp) {
      if (value != undefined) {
        return uParseTime(value, temp);
      }
      return "";
    },
    getProjectName(id) {
      return id in this.projectOptions
        ? this.projectOptions[id].project_name
        : "";
    },
    getPatientName(id) {
      return id in this.patientMap ? this.patientMap[id].name : "";
    },
    getPatientDialysisNo(id) {
      return id in this.patientMap ? this.patientMap[id].dialysis_no : "";
    },
    mergeSpan({ row, column, rowIndex, columnIndex }) {
      if (columnIndex === 0 || columnIndex === 1 || columnIndex === 3) {
        const _row = this.tableRowData[rowIndex];
        const _col = _row > 0 ? 1 : 0;
        return {
          rowspan: _row,
          colspan: _col
        };
      }
    }
  },
  components: {
    PieChart,
    BreadCrumb
  }
};
</script>

<style rel="stylesheet/scss" lang="scss" scoped>
.app-container {
  //   margin: 20px;
  font-size: 15px;
  .filter-container {
    padding-bottom: 5px;
  }
  .cqd-dataTitle {
    color: #303133;
    font-size: 14px;
    border-bottom: 2px #e4e7ed solid;
    height: 36px;
    line-height: 36px;
    margin: 0 0 25px 0;
    position: relative;
  }
  .cqd-dataTitle::before {
    position: absolute;
    left: 0;
    bottom: -2px;
    content: "";
    width: 42px;
    height: 2px;
    background: #409eff;
  }
  .search-component {
    width: 500px;
    .searchBox {
      width: 300px;
      height: 36px;
      line-height: 36px;
      padding-left: 15px;
      border: 1px #dcdfe6 solid;
      border-right: none;
      outline: none;
      float: left;
      border-radius: 6px 0 0 6px;
      font-size: 14px;
      color: #333;
      background: #fff;
      box-shadow: 3px 3px 4px rgba(135, 135, 135, 0.05);
    }
    .searchBtn {
      background-color: #409eff;
      color: #fff;
      font-size: 15px;
      text-align: center;
      height: 36px;
      line-height: 36px;
      float: left;
      outline: none;
      width: 70px;
      border: none;
      border-radius: 0 6px 6px 0;
      font-family: "Microsoft Yahei";
      cursor: pointer;
    }
  }
  .amount {
    font-weight: normal;
    padding: 10px 0 0 0;
    color: #606266;
    font-size: 14px;
    span {
      color: #ef2525;
      font-family: "Arial";
      padding: 0 2px;
    }
  }
}
</style>
<style>
.el-table td,
.el-table th.is-leaf,
.el-table--border,
.el-table--group {
  border-color: #d0d3da;
}
.el-table--border::after,
.el-table--group::after,
.el-table::before {
  background-color: #d0d3da;
}
</style>
